# Common files
require 'apcera/api_client'
require 'apcera/api_error'
require 'apcera/version'
require 'apcera/configuration'

# Models
require 'apcera/models/base_object'
require 'apcera/models/apc_download_url'
require 'apcera/models/api_error'
require 'apcera/models/audit_log_item'
require 'apcera/models/audit_log_item_old'
require 'apcera/models/binding'
require 'apcera/models/create_docker_job_request'
require 'apcera/models/create_docker_job_response'
require 'apcera/models/dependency'
require 'apcera/models/dependency_resolve'
require 'apcera/models/docker_origin'
require 'apcera/models/drain'
require 'apcera/models/drain_config'
require 'apcera/models/file_listing'
require 'apcera/models/info'
require 'apcera/models/instance_manager'
require 'apcera/models/instance_state'
require 'apcera/models/instances'
require 'apcera/models/job'
require 'apcera/models/job_health'
require 'apcera/models/job_network_reference'
require 'apcera/models/log'
require 'apcera/models/metric_series'
require 'apcera/models/metric_series_hash'
require 'apcera/models/metrics'
require 'apcera/models/namespace'
require 'apcera/models/package'
require 'apcera/models/package_depends_request'
require 'apcera/models/package_info'
require 'apcera/models/package_resource'
require 'apcera/models/policy_error'
require 'apcera/models/port'
require 'apcera/models/process'
require 'apcera/models/process_object'
require 'apcera/models/provide'
require 'apcera/models/provider'
require 'apcera/models/resource'
require 'apcera/models/restart_config'
require 'apcera/models/rollout_config'
require 'apcera/models/route'
require 'apcera/models/rule'
require 'apcera/models/runtime'
require 'apcera/models/semi_pipe_rule'
require 'apcera/models/semi_pipe_rule_action'
require 'apcera/models/service'
require 'apcera/models/service_request_object'
require 'apcera/models/stager_job'
require 'apcera/models/staging_pipeline'
require 'apcera/models/sub_task'
require 'apcera/models/subnet_info'
require 'apcera/models/task'
require 'apcera/models/task_event'
require 'apcera/models/task_progress'
require 'apcera/models/unbind_parameter_object'
require 'apcera/models/unlink_parameter_object'
require 'apcera/models/version_info'
require 'apcera/models/virtual_network'
require 'apcera/models/virtual_network_endpoint'
require 'apcera/models/virtual_network_endpoint_interface'

# APIs
require 'apcera/api/instances_api'
require 'apcera/api/virtual_networks_api'
require 'apcera/api/utilities_api'
require 'apcera/api/metrics_api'
require 'apcera/api/jobs_api'
require 'apcera/api/packages_api'
require 'apcera/api/services_and_bindings_api'
require 'apcera/api/logs_api'
require 'apcera/api/providers_api'
require 'apcera/api/rules_api'
require 'apcera/api/staging_pipelines_api'

module Apcera
  class << self
    # Configure sdk using block.
    # Apcera.configure do |config|
    #   config.username = "xxx"
    #   config.password = "xxx"
    # end
    # If no block given, return the configuration singleton instance.
    def configure
      if block_given?
        yield Configuration.instance
      else
        Configuration.instance
      end
    end
  end
end
