module Apcera
  # 
  class AuditLogItem < BaseObject
    attr_accessor :event_type, :event_type_int, :fqn, :localname, :namespace, :on_behalf_of, :payload, :principal_name, :resource_type, :timestamp, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Event type.
        :'event_type' => :'event_type',
        
        # Integer used as the index of an enumeration of human-readable event types (see `event_type`).
        :'event_type_int' => :'event_type_int',
        
        # Fully-qualified name of the resource on which the auditable action was attempted.
        :'fqn' => :'fqn',
        
        # Local name of the resource on which the auditable action was attempted.
        :'localname' => :'localname',
        
        # Namespace of the resource on which the auditable action was attempted.
        :'namespace' => :'namespace',
        
        # Username on whose behalf the auditable action was attempted by `principal_name`.
        :'on_behalf_of' => :'on_behalf_of',
        
        # Simple structured auditing data like JSON output.
        :'payload' => :'payload',
        
        # The actor (API Server or Health Manager, for example) or user that attempted the auditable action.
        :'principal_name' => :'principal_name',
        
        # The resource type on which the auditable action was attempted.
        :'resource_type' => :'resource_type',
        
        # UNIX timestamp that indicates when the event occurred.
        :'timestamp' => :'timestamp',
        
        # Unique identifier for the audit log entry.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'event_type' => :'String',
        :'event_type_int' => :'Integer',
        :'fqn' => :'String',
        :'localname' => :'String',
        :'namespace' => :'String',
        :'on_behalf_of' => :'String',
        :'payload' => :'String',
        :'principal_name' => :'String',
        :'resource_type' => :'String',
        :'timestamp' => :'Float',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'event_type']
        self.event_type = attributes[:'event_type']
      end
      
      if attributes[:'event_type_int']
        self.event_type_int = attributes[:'event_type_int']
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'localname']
        self.localname = attributes[:'localname']
      end
      
      if attributes[:'namespace']
        self.namespace = attributes[:'namespace']
      end
      
      if attributes[:'on_behalf_of']
        self.on_behalf_of = attributes[:'on_behalf_of']
      end
      
      if attributes[:'payload']
        self.payload = attributes[:'payload']
      end
      
      if attributes[:'principal_name']
        self.principal_name = attributes[:'principal_name']
      end
      
      if attributes[:'resource_type']
        self.resource_type = attributes[:'resource_type']
      end
      
      if attributes[:'timestamp']
        self.timestamp = attributes[:'timestamp']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
