module Apcera
  # 
  class Binding < BaseObject
    attr_accessor :env_var, :fqn, :job_fqn, :name, :parameters, :provider_fqn, :service_fqn, :target_job_bound_ip, :target_job_bound_port, :target_job_fqn, :target_job_port, :target_job_uuid, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # List of environment variables generated for the binding.
        :'env_var' => :'env_var',
        
        # The binding&#39;s fully-qualified name.
        :'fqn' => :'fqn',
        
        # Fully-qualified name of the job that is bound to another job or service.
        :'job_fqn' => :'job_fqn',
        
        # The base name of the binding.
        :'name' => :'name',
        
        # A map of custom binding parameter names to their values.
        :'parameters' => :'parameters',
        
        # Fully-qualified name of the provider used to create the service to which the source job is bound. Only relevant for job-to-service bindings.
        :'provider_fqn' => :'provider_fqn',
        
        # Fully-qualified name of a the service to which the source job is bound. Only relevant for for job-to-service bindings.
        :'service_fqn' => :'service_fqn',
        
        # IP address where the connection to the target job should be exposed.
        :'target_job_bound_ip' => :'target_job_bound_ip',
        
        # Port that the target job should be exposed at.
        :'target_job_bound_port' => :'target_job_bound_port',
        
        # Fully-qualified name of the job to which the source job wants to bind (input only).
        :'target_job_fqn' => :'target_job_fqn',
        
        # Port on the target job that the source job wants to bind to.
        :'target_job_port' => :'target_job_port',
        
        # UUID of the job to which the source job is bound (output only).
        :'target_job_uuid' => :'target_job_uuid',
        
        # The binding&#39;s unique identifier.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'env_var' => :'Array<String>',
        :'fqn' => :'String',
        :'job_fqn' => :'String',
        :'name' => :'String',
        :'parameters' => :'Hash<String, String>',
        :'provider_fqn' => :'String',
        :'service_fqn' => :'String',
        :'target_job_bound_ip' => :'String',
        :'target_job_bound_port' => :'String',
        :'target_job_fqn' => :'String',
        :'target_job_port' => :'String',
        :'target_job_uuid' => :'String',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'env_var']
        if (value = attributes[:'env_var']).is_a?(Array)
          self.env_var = value
        end
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'job_fqn']
        self.job_fqn = attributes[:'job_fqn']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'parameters']
        if (value = attributes[:'parameters']).is_a?(Array)
          self.parameters = value
        end
      end
      
      if attributes[:'provider_fqn']
        self.provider_fqn = attributes[:'provider_fqn']
      end
      
      if attributes[:'service_fqn']
        self.service_fqn = attributes[:'service_fqn']
      end
      
      if attributes[:'target_job_bound_ip']
        self.target_job_bound_ip = attributes[:'target_job_bound_ip']
      end
      
      if attributes[:'target_job_bound_port']
        self.target_job_bound_port = attributes[:'target_job_bound_port']
      end
      
      if attributes[:'target_job_fqn']
        self.target_job_fqn = attributes[:'target_job_fqn']
      end
      
      if attributes[:'target_job_port']
        self.target_job_port = attributes[:'target_job_port']
      end
      
      if attributes[:'target_job_uuid']
        self.target_job_uuid = attributes[:'target_job_uuid']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
