module Apcera
  # 
  class Dependency < BaseObject
    attr_accessor :name, :type
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # A string that describes the resource that can be depended on (e.g., &#39;java&#39;, &#39;apache-2.2&#39;).
        :'name' => :'name',
        
        # The type of dependency. Valid values are `file`, `package`, `runtime`, and `os`.
        :'type' => :'type'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'name' => :'String',
        :'type' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
    end

    def type=(type)
      allowed_values = ["file", "package", "runtime", "os"]
      if type && !allowed_values.include?(type)
        fail "invalid value for 'type', must be one of #{allowed_values}"
      end
      @type = type
    end

  end
end
