module Apcera
  # 
  class DockerOrigin < BaseObject
    attr_accessor :image_name, :image_tag, :registry_url, :volumes
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Name of Docker image used to create the job.
        :'image_name' => :'ImageName',
        
        # Tag assigned to the Docker image used to create the job.
        :'image_tag' => :'ImageTag',
        
        # URL of private Docker registry used to create the job. Empty for if the Docker public registry (a.k.a. DockerHub) was used.
        :'registry_url' => :'RegistryURL',
        
        # Volumes defined by the Docker image used to create the job.
        :'volumes' => :'Volumes'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'image_name' => :'String',
        :'image_tag' => :'String',
        :'registry_url' => :'String',
        :'volumes' => :'Array<String>'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'ImageName']
        self.image_name = attributes[:'ImageName']
      end
      
      if attributes[:'ImageTag']
        self.image_tag = attributes[:'ImageTag']
      end
      
      if attributes[:'RegistryURL']
        self.registry_url = attributes[:'RegistryURL']
      end
      
      if attributes[:'Volumes']
        if (value = attributes[:'Volumes']).is_a?(Array)
          self.volumes = value
        end
      end
      
    end

  end
end
