module Apcera
  # 
  class DrainConfig < BaseObject
    attr_accessor :priority, :protocol
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The configured syslog priority.
        :'priority' => :'priority',
        
        # The default syslog protocol to dial over. Defaults to TCP.
        :'protocol' => :'protocol'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'priority' => :'Integer',
        :'protocol' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'priority']
        self.priority = attributes[:'priority']
      end
      
      if attributes[:'protocol']
        self.protocol = attributes[:'protocol']
      end
      
    end

    def protocol=(protocol)
      allowed_values = ["udp", "tcp"]
      if protocol && !allowed_values.include?(protocol)
        fail "invalid value for 'protocol', must be one of #{allowed_values}"
      end
      @protocol = protocol
    end

  end
end
