module Apcera
  # 
  class InstanceManager < BaseObject
    attr_accessor :resources_provisioned, :resources_total, :datacenter, :hostname, :num_instances, :start_time, :system_tags, :tags, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # 
        :'resources_provisioned' => :'ResourcesProvisioned',
        
        # 
        :'resources_total' => :'ResourcesTotal',
        
        # 
        :'datacenter' => :'datacenter',
        
        # Instance manager&#39;s host name.
        :'hostname' => :'hostname',
        
        # The number of instances being managed by the instance manager.
        :'num_instances' => :'num_instances',
        
        # Date and time that instance manager was started.
        :'start_time' => :'start_time',
        
        # System tags assigned to the instance manager.
        :'system_tags' => :'system_tags',
        
        # Tags assigned to the instance manager.
        :'tags' => :'tags',
        
        # Instance manager&#39;s unique identifier.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'resources_provisioned' => :'Resource',
        :'resources_total' => :'Resource',
        :'datacenter' => :'String',
        :'hostname' => :'String',
        :'num_instances' => :'Integer',
        :'start_time' => :'String',
        :'system_tags' => :'Array<String>',
        :'tags' => :'Array<String>',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'ResourcesProvisioned']
        self.resources_provisioned = attributes[:'ResourcesProvisioned']
      end
      
      if attributes[:'ResourcesTotal']
        self.resources_total = attributes[:'ResourcesTotal']
      end
      
      if attributes[:'datacenter']
        self.datacenter = attributes[:'datacenter']
      end
      
      if attributes[:'hostname']
        self.hostname = attributes[:'hostname']
      end
      
      if attributes[:'num_instances']
        self.num_instances = attributes[:'num_instances']
      end
      
      if attributes[:'start_time']
        self.start_time = attributes[:'start_time']
      end
      
      if attributes[:'system_tags']
        if (value = attributes[:'system_tags']).is_a?(Array)
          self.system_tags = value
        end
      end
      
      if attributes[:'tags']
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
