module Apcera
  # 
  class InstanceState < BaseObject
    attr_accessor :first_running, :new, :removed, :running, :setup, :starting, :starting_wait, :stopping, :stopping_wait, :teardown, :updating
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Number of instances where the job was started and is about to move into the `RUNNING` state.
        :'first_running' => :'FIRST_RUNNING',
        
        # Number of instances in the `NEW` state.
        :'new' => :'NEW',
        
        # Number of instances that are no longer consuming resources and have no remaining configuration on the system.
        :'removed' => :'REMOVED',
        
        # Number of instances that are running.
        :'running' => :'RUNNING',
        
        # Number of instances in which packages are being installed, networking initialized, etc.
        :'setup' => :'SETUP',
        
        # Number of instances whose processes have been started, but have not been verified to be running.
        :'starting' => :'STARTING',
        
        # Number of instances that are waiting for dependent jobs to become ready.
        :'starting_wait' => :'STARTING_WAIT',
        
        # Number of instances that are in the process of having their processes shutdown.
        :'stopping' => :'STOPPING',
        
        # Number of instances that are being stopped, but have jobs depending on it. In this case the other jobs must first transition past the `STOPPING` state before this instance can be stopped.
        :'stopping_wait' => :'STOPPING_WAIT',
        
        # Number of instances whose user-defined processes have been killed, and the instance is being removed from cluster resources.
        :'teardown' => :'TEARDOWN',
        
        # Number of instances that are in a state that allows the instance to update various properties of the container.
        :'updating' => :'UPDATING'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'first_running' => :'Integer',
        :'new' => :'Integer',
        :'removed' => :'Integer',
        :'running' => :'Integer',
        :'setup' => :'Integer',
        :'starting' => :'Integer',
        :'starting_wait' => :'Integer',
        :'stopping' => :'Integer',
        :'stopping_wait' => :'Integer',
        :'teardown' => :'Integer',
        :'updating' => :'Integer'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'FIRST_RUNNING']
        self.first_running = attributes[:'FIRST_RUNNING']
      end
      
      if attributes[:'NEW']
        self.new = attributes[:'NEW']
      end
      
      if attributes[:'REMOVED']
        self.removed = attributes[:'REMOVED']
      end
      
      if attributes[:'RUNNING']
        self.running = attributes[:'RUNNING']
      end
      
      if attributes[:'SETUP']
        self.setup = attributes[:'SETUP']
      end
      
      if attributes[:'STARTING']
        self.starting = attributes[:'STARTING']
      end
      
      if attributes[:'STARTING_WAIT']
        self.starting_wait = attributes[:'STARTING_WAIT']
      end
      
      if attributes[:'STOPPING']
        self.stopping = attributes[:'STOPPING']
      end
      
      if attributes[:'STOPPING_WAIT']
        self.stopping_wait = attributes[:'STOPPING_WAIT']
      end
      
      if attributes[:'TEARDOWN']
        self.teardown = attributes[:'TEARDOWN']
      end
      
      if attributes[:'UPDATING']
        self.updating = attributes[:'UPDATING']
      end
      
    end

  end
end
