module Apcera
  # 
  class JobHealth < BaseObject
    attr_accessor :flapping, :instance_state_count, :score, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Indicates if job is in a flapping state (true) or not (false).
        :'flapping' => :'flapping',
        
        # Map of instance states to the number of instances in that state, as reported by the health manager.
        :'instance_state_count' => :'instance_state_count',
        
        # Score is the ratio of running instances to configured instances, capped between 0 and 1.
        :'score' => :'score',
        
        # UUID of the job.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'flapping' => :'BOOLEAN',
        :'instance_state_count' => :'Hash<String, InstanceState>',
        :'score' => :'Integer',
        :'uuid' => :'BOOLEAN'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'flapping']
        self.flapping = attributes[:'flapping']
      end
      
      if attributes[:'instance_state_count']
        if (value = attributes[:'instance_state_count']).is_a?(Array)
          self.instance_state_count = value
        end
      end
      
      if attributes[:'score']
        self.score = attributes[:'score']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
