module Apcera
  # 
  class PackageResource < BaseObject
    attr_accessor :digest, :length, :sha1, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # A hash of the binary resource prefixed by its algorithm (e.g. &#39;sha1:abcd...&#39;).
        :'digest' => :'digest',
        
        # The length of the binary resource in bytes.
        :'length' => :'length',
        
        # A hash of the binary resource.
        :'sha1' => :'sha1',
        
        # The package resource&#39;s unique identifier.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'digest' => :'String',
        :'length' => :'Integer',
        :'sha1' => :'String',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'digest']
        self.digest = attributes[:'digest']
      end
      
      if attributes[:'length']
        self.length = attributes[:'length']
      end
      
      if attributes[:'sha1']
        self.sha1 = attributes[:'sha1']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
