module Apcera
  # 
  class PolicyError < BaseObject
    attr_accessor :errors, :job, :job_changed, :repairable
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # An array of specific policy errors that occurred.
        :'errors' => :'errors',
        
        # A reference to the job associated with the policy error.
        :'job' => :'job',
        
        # If `true`, the policy error was the result of changes to a job.
        :'job_changed' => :'job_changed',
        
        # If `true`, the error is repairable.
        :'repairable' => :'repairable'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'errors' => :'Array<String>',
        :'job' => :'Job',
        :'job_changed' => :'BOOLEAN',
        :'repairable' => :'BOOLEAN'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'errors']
        if (value = attributes[:'errors']).is_a?(Array)
          self.errors = value
        end
      end
      
      if attributes[:'job']
        self.job = attributes[:'job']
      end
      
      if attributes[:'job_changed']
        self.job_changed = attributes[:'job_changed']
      end
      
      if attributes[:'repairable']
        self.repairable = attributes[:'repairable']
      end
      
    end

  end
end
