module Apcera
  # 
  class Port < BaseObject
    attr_accessor :number, :optional, :routes
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The numerical port exposed for connectivity.
        :'number' => :'number',
        
        # A value of `true` indicates that the instance manager (IM) should attempt to verify that connectivity has been established for this port; if `false`, no such verification occurs.
        :'optional' => :'optional',
        
        # An array of URLs to map to the port.
        :'routes' => :'routes'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'number' => :'Integer',
        :'optional' => :'BOOLEAN',
        :'routes' => :'Array<Route>'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'number']
        self.number = attributes[:'number']
      end
      
      if attributes[:'optional']
        self.optional = attributes[:'optional']
      end
      
      if attributes[:'routes']
        if (value = attributes[:'routes']).is_a?(Array)
          self.routes = value
        end
      end
      
    end

  end
end
