module Apcera
  # 
  class RestartConfig < BaseObject
    attr_accessor :maximum_attempts, :restart_mode
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The maximum number of restart attempts per instance, applies to `always` and `failure` restart modes. If set to 0 restarts are not limited.
        :'maximum_attempts' => :'maximum_attempts',
        
        # The restart mode to use. Valid values are `always` (always restart), `no` (never restart), and `failure` (only restart on application failure).
        :'restart_mode' => :'restart_mode'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'maximum_attempts' => :'Integer',
        :'restart_mode' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'maximum_attempts']
        self.maximum_attempts = attributes[:'maximum_attempts']
      end
      
      if attributes[:'restart_mode']
        self.restart_mode = attributes[:'restart_mode']
      end
      
    end

    def restart_mode=(restart_mode)
      allowed_values = ["always", "no", "failure"]
      if restart_mode && !allowed_values.include?(restart_mode)
        fail "invalid value for 'restart_mode', must be one of #{allowed_values}"
      end
      @restart_mode = restart_mode
    end

  end
end
