module Apcera
  # 
  class RolloutConfig < BaseObject
    attr_accessor :errored_state_window, :flapping_minimum_restarts, :flapping_percent, :flapping_window, :force_stop_old_instances_after
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The number of seconds a job should be cycling between flapping states before being considered in an errored state and stop attempting any restarts.
        :'errored_state_window' => :'errored_state_window',
        
        # The minimum number of tasks that must have failed in order to trigger a flapping state.
        :'flapping_minimum_restarts' => :'flapping_minimum_restarts',
        
        # The number of instances that must have restarted in a given window for flapping to kick in.
        :'flapping_percent' => :'flapping_percent',
        
        # The number of seconds over which the job&#39;s flapping window operates.
        :'flapping_window' => :'flapping_window',
        
        # If this field is non-zero then it will be used to represent how long an old version of a job is allowed to exist in the cluster. If this is zero then no fixed length is established and updates will be applied by starting a new version and then only when that instance is running will the old instance be killed.
        :'force_stop_old_instances_after' => :'force_stop_old_instances_after'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'errored_state_window' => :'Integer',
        :'flapping_minimum_restarts' => :'Integer',
        :'flapping_percent' => :'Float',
        :'flapping_window' => :'Integer',
        :'force_stop_old_instances_after' => :'Integer'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'errored_state_window']
        self.errored_state_window = attributes[:'errored_state_window']
      end
      
      if attributes[:'flapping_minimum_restarts']
        self.flapping_minimum_restarts = attributes[:'flapping_minimum_restarts']
      end
      
      if attributes[:'flapping_percent']
        self.flapping_percent = attributes[:'flapping_percent']
      end
      
      if attributes[:'flapping_window']
        self.flapping_window = attributes[:'flapping_window']
      end
      
      if attributes[:'force_stop_old_instances_after']
        self.force_stop_old_instances_after = attributes[:'force_stop_old_instances_after']
      end
      
    end

  end
end
