module Apcera
  # 
  class Route < BaseObject
    attr_accessor :endpoint, :type, :weight
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The URI where the traffic should being routed to. For HTTP routes, the value should contain the route&#39;s host and path; for TCP routes, the value should take the form of \&quot;ip:port\&quot;.
        :'endpoint' => :'endpoint',
        
        # The type of route. Valid values are `http` or `tcp`.
        :'type' => :'type',
        
        # A value between 0 and 1 that specifies the route&#39;s weight, which is used to balance incoming traffic across apps that share the route. Weights are not on a specific scale; weights of all routes for a given job are normalized.
        :'weight' => :'weight'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'endpoint' => :'String',
        :'type' => :'String',
        :'weight' => :'Float'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'endpoint']
        self.endpoint = attributes[:'endpoint']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
      if attributes[:'weight']
        self.weight = attributes[:'weight']
      end
      
    end

  end
end
