module Apcera
  # 
  class SemiPipeRule < BaseObject
    attr_accessor :action, :created_at, :created_by, :job, :name, :provider, :service, :type, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # 
        :'action' => :'action',
        
        # Date-time when rule was created.
        :'created_at' => :'created_at',
        
        # User that created the rule.
        :'created_by' => :'created_by',
        
        # Specific job that rule applies to.
        :'job' => :'job',
        
        # Rule name.
        :'name' => :'name',
        
        # Provider used to provision the service, if any.
        :'provider' => :'provider',
        
        # FQN of service to which the rule applies.
        :'service' => :'service',
        
        # Rule type.
        :'type' => :'type',
        
        # Rule&#39;s unique identifier.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'action' => :'SemiPipeRuleAction',
        :'created_at' => :'DateTime',
        :'created_by' => :'String',
        :'job' => :'String',
        :'name' => :'String',
        :'provider' => :'String',
        :'service' => :'String',
        :'type' => :'Integer',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'action']
        self.action = attributes[:'action']
      end
      
      if attributes[:'created_at']
        self.created_at = attributes[:'created_at']
      end
      
      if attributes[:'created_by']
        self.created_by = attributes[:'created_by']
      end
      
      if attributes[:'job']
        self.job = attributes[:'job']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'provider']
        self.provider = attributes[:'provider']
      end
      
      if attributes[:'service']
        self.service = attributes[:'service']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
