module Apcera
  # 
  class Service < BaseObject
    attr_accessor :created_at, :created_by, :description, :extended_status, :fqn, :name, :parameters, :provider_fqn, :status, :type, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # UNIX timestamp when service was created.
        :'created_at' => :'created_at',
        
        # Principal name of the user who created the service.
        :'created_by' => :'created_by',
        
        # A human-readable description of the service.
        :'description' => :'description',
        
        # A map of custom binding parameter names to their values.
        :'extended_status' => :'extended_status',
        
        # Service&#39;s fully-qualified name.
        :'fqn' => :'fqn',
        
        # The base name of the binding.
        :'name' => :'name',
        
        # A map of service parameter names to values.
        :'parameters' => :'parameters',
        
        # Fully-qualified name of provider used to create service.
        :'provider_fqn' => :'provider_fqn',
        
        # The status of service.
        :'status' => :'status',
        
        # A service type (&#39;mysql&#39;, &#39;postgres&#39;, &#39;mongodb&#39;, etc.) that corresponds to a service gateway of that type.
        :'type' => :'type',
        
        # Service&#39;s unique identifer
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'created_at' => :'DateTime',
        :'created_by' => :'String',
        :'description' => :'String',
        :'extended_status' => :'Hash<String, String>',
        :'fqn' => :'String',
        :'name' => :'String',
        :'parameters' => :'Object',
        :'provider_fqn' => :'String',
        :'status' => :'String',
        :'type' => :'String',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'created_at']
        self.created_at = attributes[:'created_at']
      end
      
      if attributes[:'created_by']
        self.created_by = attributes[:'created_by']
      end
      
      if attributes[:'description']
        self.description = attributes[:'description']
      end
      
      if attributes[:'extended_status']
        if (value = attributes[:'extended_status']).is_a?(Array)
          self.extended_status = value
        end
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'parameters']
        self.parameters = attributes[:'parameters']
      end
      
      if attributes[:'provider_fqn']
        self.provider_fqn = attributes[:'provider_fqn']
      end
      
      if attributes[:'status']
        self.status = attributes[:'status']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
