module Apcera
  # 
  class ServiceRequestObject < BaseObject
    attr_accessor :description, :fqn, :name, :parameters, :provider_fqn, :type
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # A description of the service.
        :'description' => :'description',
        
        # The service&#39;s fully-qualified name.
        :'fqn' => :'fqn',
        
        # A human-readable description of the service.
        :'name' => :'name',
        
        # A map of service parameter names to values.
        :'parameters' => :'parameters',
        
        # The fully-qualified name of provider used to create service.
        :'provider_fqn' => :'provider_fqn',
        
        # A service type (&#39;mysql&#39;, &#39;postgres&#39;, &#39;mongodb&#39;, etc.) that corresponds to a service gateway of that type.
        :'type' => :'type'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'description' => :'String',
        :'fqn' => :'String',
        :'name' => :'String',
        :'parameters' => :'Object',
        :'provider_fqn' => :'String',
        :'type' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'description']
        self.description = attributes[:'description']
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'parameters']
        self.parameters = attributes[:'parameters']
      end
      
      if attributes[:'provider_fqn']
        self.provider_fqn = attributes[:'provider_fqn']
      end
      
      if attributes[:'type']
        self.type = attributes[:'type']
      end
      
    end

  end
end
