module Apcera
  # 
  class StagingPipeline < BaseObject
    attr_accessor :created_at, :created_by, :fqn, :name, :stagers, :updated_at, :updated_by, :uuid, :version_id
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # The date and time when the staging pipeline was created.
        :'created_at' => :'created_at',
        
        # Principal name of the user who created the staging pipeline.
        :'created_by' => :'created_by',
        
        # Staging pipeline&#39;s FQN.
        :'fqn' => :'fqn',
        
        # Staging pipeline&#39;s local name.
        :'name' => :'name',
        
        # The list of jobs that will be cloned in order to make the specific stager instances.
        :'stagers' => :'stagers',
        
        # The date and time when the staging pipeline was most recently updated.
        :'updated_at' => :'updated_at',
        
        # Principal name of the user who last updated the staging pipeline.
        :'updated_by' => :'updated_by',
        
        # Staging pipeline&#39;s unique identifier.
        :'uuid' => :'uuid',
        
        # Staging pipeline&#39;s auto-incremented version number.
        :'version_id' => :'version_id'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'created_at' => :'DateTime',
        :'created_by' => :'String',
        :'fqn' => :'String',
        :'name' => :'String',
        :'stagers' => :'Array<StagerJob>',
        :'updated_at' => :'DateTime',
        :'updated_by' => :'String',
        :'uuid' => :'String',
        :'version_id' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'created_at']
        self.created_at = attributes[:'created_at']
      end
      
      if attributes[:'created_by']
        self.created_by = attributes[:'created_by']
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'stagers']
        if (value = attributes[:'stagers']).is_a?(Array)
          self.stagers = value
        end
      end
      
      if attributes[:'updated_at']
        self.updated_at = attributes[:'updated_at']
      end
      
      if attributes[:'updated_by']
        self.updated_by = attributes[:'updated_by']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
      if attributes[:'version_id']
        self.version_id = attributes[:'version_id']
      end
      
    end

  end
end
