module Apcera
  # 
  class Task < BaseObject
    attr_accessor :errored, :events, :state, :time_completed, :time_started, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Describes the error for a Task that has encountered an error.
        :'errored' => :'errored',
        
        # List of all TaskEvents that have been published for this particular task.
        :'events' => :'events',
        
        # The Task&#39;s current state. Can be `running`, `stopped` or `complete`.
        :'state' => :'state',
        
        # Indicates the time when the task completed. Stored as a UNIX timestamp with nanosecond precision.
        :'time_completed' => :'time_completed',
        
        # Indicates the time when the task was started. Stored as a UNIX timestamp with nanosecond precision.
        :'time_started' => :'time_started',
        
        # The task&#39;s unique identifier.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'errored' => :'String',
        :'events' => :'Array<TaskEvent>',
        :'state' => :'String',
        :'time_completed' => :'Integer',
        :'time_started' => :'Integer',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'errored']
        self.errored = attributes[:'errored']
      end
      
      if attributes[:'events']
        if (value = attributes[:'events']).is_a?(Array)
          self.events = value
        end
      end
      
      if attributes[:'state']
        self.state = attributes[:'state']
      end
      
      if attributes[:'time_completed']
        self.time_completed = attributes[:'time_completed']
      end
      
      if attributes[:'time_started']
        self.time_started = attributes[:'time_started']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

    def state=(state)
      allowed_values = ["running", "stopped", "complete"]
      if state && !allowed_values.include?(state)
        fail "invalid value for 'state', must be one of #{allowed_values}"
      end
      @state = state
    end

  end
end
