module Apcera
  # 
  class VersionInfo < BaseObject
    attr_accessor :build_id, :build_number, :download_urls, :major, :minor, :patch, :version
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # Cluster&#39;s build ID.
        :'build_id' => :'build_id',
        
        # Cluster build number composed of the cluster&#39;s major, minor and patch version numbers (for example, \&quot;2.2.0\&quot;).
        :'build_number' => :'build_number',
        
        # Provides download links for versions of APC compatible this cluster.
        :'download_urls' => :'download_urls',
        
        # Major Apcera cluster version number.
        :'major' => :'major',
        
        # Minor Apcera cluster version number.
        :'minor' => :'minor',
        
        # Cluster patch number.
        :'patch' => :'patch',
        
        # Cluster version string composed of the cluster&#39;s major, minor and patch version numbers (for example, \&quot;2.2.0\&quot;).
        :'version' => :'version'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'build_id' => :'String',
        :'build_number' => :'String',
        :'download_urls' => :'Hash<String, APCDownloadURL>',
        :'major' => :'Integer',
        :'minor' => :'Integer',
        :'patch' => :'Integer',
        :'version' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'build_id']
        self.build_id = attributes[:'build_id']
      end
      
      if attributes[:'build_number']
        self.build_number = attributes[:'build_number']
      end
      
      if attributes[:'download_urls']
        if (value = attributes[:'download_urls']).is_a?(Array)
          self.download_urls = value
        end
      end
      
      if attributes[:'major']
        self.major = attributes[:'major']
      end
      
      if attributes[:'minor']
        self.minor = attributes[:'minor']
      end
      
      if attributes[:'patch']
        self.patch = attributes[:'patch']
      end
      
      if attributes[:'version']
        self.version = attributes[:'version']
      end
      
    end

  end
end
