module Apcera
  # 
  class VirtualNetwork < BaseObject
    attr_accessor :created_at, :created_by, :description, :fqn, :name, :network_end_points, :subnet_info, :updated_at, :updated_by, :uuid, :version_id
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # UNIX timestamp when the network was created.
        :'created_at' => :'created_at',
        
        # Principal name of user who created the network.
        :'created_by' => :'created_by',
        
        # Network description.
        :'description' => :'description',
        
        # Network&#39;s fully-qualified name.
        :'fqn' => :'fqn',
        
        # Network&#39;s local name.
        :'name' => :'name',
        
        # A list of network endpoints in the network.
        :'network_end_points' => :'network_end_points',
        
        # Contains information about the network&#39;s subnet.
        :'subnet_info' => :'subnet_info',
        
        # UNIX timestamp when the network was last updated.
        :'updated_at' => :'updated_at',
        
        # Principal name of user who last updated the network.
        :'updated_by' => :'updated_by',
        
        # Network&#39;s unique ID.
        :'uuid' => :'uuid',
        
        # Auto-incrementing version number for the network.
        :'version_id' => :'version_id'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'created_at' => :'Float',
        :'created_by' => :'String',
        :'description' => :'String',
        :'fqn' => :'String',
        :'name' => :'String',
        :'network_end_points' => :'Array<VirtualNetworkEndpoint>',
        :'subnet_info' => :'SubnetInfo',
        :'updated_at' => :'Float',
        :'updated_by' => :'String',
        :'uuid' => :'String',
        :'version_id' => :'Integer'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'created_at']
        self.created_at = attributes[:'created_at']
      end
      
      if attributes[:'created_by']
        self.created_by = attributes[:'created_by']
      end
      
      if attributes[:'description']
        self.description = attributes[:'description']
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'network_end_points']
        if (value = attributes[:'network_end_points']).is_a?(Array)
          self.network_end_points = value
        end
      end
      
      if attributes[:'subnet_info']
        self.subnet_info = attributes[:'subnet_info']
      end
      
      if attributes[:'updated_at']
        self.updated_at = attributes[:'updated_at']
      end
      
      if attributes[:'updated_by']
        self.updated_by = attributes[:'updated_by']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
      if attributes[:'version_id']
        self.version_id = attributes[:'version_id']
      end
      
    end

  end
end
