module Apcera
  # 
  class VirtualNetworkEndpoint < BaseObject
    attr_accessor :end_point_interface, :fqn, :network_fqn, :uuid
    # attribute mapping from ruby-style variable name to JSON key
    def self.attribute_map
      {
        
        # A list of interfaces associated with the job.
        :'end_point_interface' => :'end_point_interface',
        
        # Fully-qualified name of the job the endpoint is attached to.
        :'fqn' => :'fqn',
        
        # Fully-qualified name of the network that the endpoint belongs to.
        :'network_fqn' => :'network_fqn',
        
        # The UUID of the network endpoint.
        :'uuid' => :'uuid'
        
      }
    end

    # attribute type
    def self.swagger_types
      {
        :'end_point_interface' => :'Array<VirtualNetworkEndpointInterface>',
        :'fqn' => :'String',
        :'network_fqn' => :'String',
        :'uuid' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return if !attributes.is_a?(Hash) || attributes.empty?

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'end_point_interface']
        if (value = attributes[:'end_point_interface']).is_a?(Array)
          self.end_point_interface = value
        end
      end
      
      if attributes[:'fqn']
        self.fqn = attributes[:'fqn']
      end
      
      if attributes[:'network_fqn']
        self.network_fqn = attributes[:'network_fqn']
      end
      
      if attributes[:'uuid']
        self.uuid = attributes[:'uuid']
      end
      
    end

  end
end
